import 'dart:convert';

import 'package:bui_component/CardComponent/cardComponent.dart';
import 'package:bui_component/Constants/AppStrings.dart';
import 'package:bui_component/Constants/SvgPictures.dart';
import 'package:bui_component/JsonFormComponent/json_schema.dart';
import 'package:example/Constants/AppColors.dart';
import 'package:example/Utils/Utility.dart';
import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:toast/toast.dart';

class ButtonView extends StatefulWidget {
  Color primaryColor;
  Color secondaryColor;

  ButtonView({this.primaryColor, this.secondaryColor});

  @override
  _ButtonViewState createState() => _ButtonViewState();
}

class _ButtonViewState extends State<ButtonView> {
  List<ModuleList> moduleList = [
    ModuleList(name: "CRM", id: "1"),
    ModuleList(name: "PMO", id: "2"),
    ModuleList(name: "ERP", id: "3"),
  ];

  String form = json.encode({
    'fields': [
      {
        'apiKeyValue': 'dueDate',
        'key': 'dueDate',
        'type': 'date',
        'label': 'Start Date',
        'required': true,
        'keyboardType': 'number',
        'validator': 'text',
        'value': "",
      },
      {
        'apiKeyValue': 'dueDate',
        'key': 'dueDate',
        'type': 'date',
        'label': 'End Date',
        'required': true,
        'readOnly': true,
        'keyboardType': 'number',
        'validator': 'text',
        'value': "",
      },
      {
        'apiKeyValue': 'statusid',
        'key': 'Status',
        'type': 'select',
        'label': 'Status',
        'required': true,
        'readOnly': true,
        'keyboardType': 'text',
        'validator': 'text',
        'value': '1',
        'items': [
          {'label': 'New', 'value': '1'},
          {'label': 'Active', 'value': '2'},
          {'label': 'Inactive', 'value': '3'},
        ]
      },
      {
        'apiKeyValue': 'statusid',
        'key': 'Status',
        'type': 'select',
        'label': 'Test',
        'required': true,
        'readOnly': false,
        'keyboardType': 'text',
        'validator': 'text',
        'value': '1',
        'items': [
          {'label': 'New', 'value': '1'},
          {'label': 'Active', 'value': '2'},
          {'label': 'Inactive', 'value': '3'},
        ]
      },
      {
        'key': 'checkbox1',
        'type': 'checkbox',
        'label': 'Checkbox test',
        'required': true,
        'readOnly': false,
        'items': [
          {
            'label': "New",
            'value': true,
          },
          {
            'label': "Folow",
            'value': false,
          },
          {
            'label': "Hot",
            'value': false,
          },
          {
            'label': "Lost",
            'value': false,
          },
          {
            'label': "Won",
            'value': false,
          },
        ]
      },
      {
        'key': 'checkbox1',
        'type': 'checkbox',
        'label': 'Checkbox test1',
        'required': true,
        'readOnly': true,
        'items': [
          {
            'label': "New",
            'value': true,
          },
          {
            'label': "Folow",
            'value': false,
          },
          {
            'label': "Hot",
            'value': false,
          },
          {
            'label': "Lost",
            'value': false,
          },
          {
            'label': "Won",
            'value': false,
          },
        ]
      },
      {
        'key': 'radiobutton1',
        'type': 'radioButton',
        'label': 'Radio Button tests',
        'value': 2,
        'required': true,
        'readOnly': false,
        'items': [
          {
            'label': "product 1",
            'value': 1,
          },
          {
            'label': "product 2",
            'value': 2,
          },
          {
            'label': "product 3",
            'value': 3,
          }
        ]
      },
      {
        'key': 'radiobutton1',
        'type': 'radioButton',
        'label': 'Radio Button tests1',
        'value': 2,
        'required': true,
        'readOnly': true,
        'items': [
          {
            'label': "product 1",
            'value': 1,
          },
          {
            'label': "product 2",
            'value': 2,
          },
          {
            'label': "product 3",
            'value': 3,
          }
        ]
      },
      {
        'key': 'switch1',
        'type': 'switch',
        'label': 'Switch test',
        'value': false,
        'required': true,
        'readOnly': false,
      },
      {
        'key': 'switch1',
        'type': 'switch',
        'label': 'Switch test1',
        'value': false,
        'required': true,
        'readOnly': true,
      },
    ]
  });
  dynamic response;

  Map decorations = {
    'input1': InputDecoration(
      prefixIcon: Icon(Icons.email),
      border: OutlineInputBorder(),
    ),
    'FirstName': InputDecoration(
      prefixIcon: Icon(Icons.person),
      border: OutlineInputBorder(),
    ),
    'Id': InputDecoration(
      prefixIcon: Icon(Icons.phone_android),
      border: OutlineInputBorder(),
    ),
    'tareatext1': InputDecoration(
      prefixIcon: Icon(Icons.description),
      border: OutlineInputBorder(),
    ),
    'password1': InputDecoration(
        prefixIcon: Icon(Icons.lock), border: OutlineInputBorder()),
  };

  Map validations = {'password1': validationExample};
  Map errorText = {
    'input1': "Error Value",
    'password1': "Enter the Password",
  };

  static String validationExample(field, value) {
    String pattern =
        r'^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9])(?=.*?[!@#\$&*~]).{8,}$';
    RegExp regExp = new RegExp(pattern);

    if (value.isEmpty) {
      return 'Please enter some text';
    }
    if (value.length < 8) {
      return 'Password is too short';
    }

    if (!regExp.hasMatch(value)) {
      return 'Password contains Minimum 1 Upper case Minimum 1 lowercase Minimum 1 Numeric Number Minimum 1 Special Character Common Allow Character ( ! @ # \$ & * ~ )';
    }
    return null;
  }

  SharedPreferences prefs;

  Color theme = AppColors.APP_COLOR_PRIMARY;

  @override
  void initState() {
    // TODO: implement initState
    super.initState();

    colorCodePref();
  }

  colorCodePref() async {
    prefs = await SharedPreferences.getInstance();

    String stringValue = prefs.getString(AppStrings.PRIMARY_THEME_COLOR);
    if (stringValue != null) {
      int colorCodeInt = int.parse(stringValue);

      setState(() {
        theme = Color(colorCodeInt);
        this.mounted;
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(
          title: Text("Filter"),
          backgroundColor:theme,
          leading: IconButton(
            icon: Icon(Icons.arrow_back_rounded),
            onPressed: () {
              FocusScope.of(context).requestFocus(new FocusNode());
              Navigator.pop(context);
            },
          ),
        ),
        body: _cardView);
  }

  Widget get _formView {
    return ListView(
      children: [
        new JsonSchema(
          secondaryColor: widget.secondaryColor,
          primaryColor: widget.primaryColor,
          decorations: decorations,
          form: form,
          validations: validations,
          errorMessages: errorText,
          onChanged: (dynamic response) {
            this.response = response;
          },
          actionSave: (data) {
            Utils.hideKeyboard(context);
            var jsonObj = {
              for (int i = 0; i < data['fields'].length; i++)
                json.encode(data['fields'][i]['value'].toString().trimLeft())
            };
          },
          buttonSave: true,
          actionCancel: () {
            Navigator.pop(context);
          },
        ),
      ],
    );
  }

  Widget get _cardView {
    return Container(
      alignment: Alignment.center,
      width: MediaQuery.of(context).size.width,
      padding: EdgeInsets.all(5),
      child: GridView.builder(
          gridDelegate: SliverGridDelegateWithMaxCrossAxisExtent(
              maxCrossAxisExtent: 200,
              childAspectRatio: 3 / 2,
              crossAxisSpacing: 1,
              mainAxisSpacing: 1),
          itemCount: moduleList.length,
          itemBuilder: (BuildContext ctx, index) {
            return InkWell(
                radius: 30,
                enableFeedback: true,
                splashColor: AppColors.halfWhite,
                onTap: () {
                  Toast.show("index", context);
                },
                child: BUICard.imageWithTextCard(
                  isVisible: true,
                  gradientColor: [
                    theme,
                    theme,
                    Colors.grey.shade50.withOpacity(1)
                  ],
                  cardText: moduleList[index].name,
                  cardTextColor: AppColors.APP_COLOR_WHITE,
                  cardType: CardType.cardWithImageAndText,
                  svgImage: SvgPictures.GOOGLE_SVG,
                ));
          }),
    );
  }
}

class ModuleList {
  String name;
  String id;

  ModuleList({this.name, this.id});
}
